<template>
  <div
    class="ui modal"
    id="new-user-modal"
  >
    <i class="close icon"></i>
    <div class="header">
      Ajouter un nouvel utilisateur
    </div>
    <div class="content">
      <form
        class="ui form"
        @submit.prevent="submit"
      >
        <div class="fields">
          <div class="six wide field">
            <label>Prénom</label>
            <input
              placeholder="Prénom"
              type="text"
              required
              v-model="firstname"
            >
          </div>
          <div class="six wide field">
            <label>Nom</label>
            <input
              placeholder="Nom de famille"
              type="text"
              required
              v-model="lastname"
            >
          </div>
        </div>

        <div class="fields">
          <div class="required field">
            <label>Nom d'utilisateur</label>
            <input
              placeholder="Nom d'utilisateur"
              type="text"
              required
              v-model="username"
            >
          </div>
          <div class="required field">
            <label>Mot de passe</label>
            <input
              style="background-image: url(&quot;data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR4nGP6zwAAAgcBApocMXEAAAAASUVORK5CYII=&quot;);" autocomplete="off"
              type="password"
              required
              v-model="password"
            >
          </div>
          <div class="required field">
            <label>Confirmation</label>
            <input
              style="background-image: url(&quot;data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR4nGP6zwAAAgcBApocMXEAAAAASUVORK5CYII=&quot;);" autocomplete="off"
              type="password"
              required
              v-model="passwordConf"
            >
          </div>
        </div>

        <div class="fields">
          <div class="required field">
            <label>Rôle</label>
            <dropdown-roles
              :initialRole="role"
              @roleChanged="updateRole"
            >
            </dropdown-roles>
          </div>
          <div class="field">
            <label>Pavillon</label>
            <dropdown-pavillons
              @pavillonChanged="updatePavillon"
            >
            </dropdown-pavillons>
          </div>
        </div>
      </form>
    </div>
    <div class="actions">
      <div
        class="ui toggle checkbox"
        @click="toggleAddAnother"
      >
        <input
          name="addAnother"
          type="checkbox"
          class="hidden"
          tabindex="0"
          :checked="addAnother"
        >
        <label>Ajouter un autre ensuite</label>
      </div>

      <div
        class="ui red basic button"
        @click="cancel"
      >Anuler</div>

      <div
        class="ui primary button"
        :class="loading ? 'loading disabled' : ''"
        @click="submit"
      >OK</div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

import store from '@/store/Store'
import DropdownDiets from '@/components/diets/DropdownDiets'
import DropdownPavillons from '@/components/pavillons/DropdownPavillons'
import DropdownRoles from './DropdownRoles'

export default {
  name: 'ModalNewUser',
  store,
  props: {
    authUserPavillon: Object
  },
  data () {
    return {
      addAnother: false,
      firstname: '',
      lastname: '',
      username: '',
      password: '',
      passwordConf: '',
      role: '',
      pavillon: null
    }
  },
  mounted () {
    // eslint-disable-next-line
    $('#new-user-modal')
      .modal('setting', 'transition', 'scale')
  },
  methods: {
    ...mapActions({
      addUser: 'UsersStore/addUser'
    }),
    toggleAddAnother () {
      this.addAnother = !this.addAnother
    },
    updatePavillon (id) {
      if (this.pavillon === null) {
        this.pavillon = {}
      }
      this.pavillon._id = id
    },
    updateRole (role) {
      this.role = role
    },
    cancel () {
      // eslint-disable-next-line
      $('#new-user-modal')
        .modal('hide')
    },
    submit () {
      var self = this

      let user = {
        firstname: this.firstname,
        lastname: this.lastname,
        username: this.username,
        password: this.password,
        passwordConf: this.passwordConf,
        role: this.role
      }
      if (this.pavillon) {
        user.pavillon = this.pavillon
      }

      this.addUser(user)
        .then((response) => {
          this.$toastr.s((response.firstname && response.lastname ? response.firstname + ' ' + response.lastname : response.username) + ' bien ajouté')
          if (!self.addAnother) {
            // eslint-disable-next-line
            $('#new-user-modal')
              .modal('hide')
          }
          this.emptyModal()
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    emptyModal () {
      // vider les champs
      this.firstname = ''
      this.lastname = ''
      this.username = ''
      this.password = ''
      this.passwordConf = ''
    }
  },
  computed: {
    ...mapGetters({
      loading: 'loading'
    })
  },
  components: {
    DropdownDiets,
    DropdownPavillons,
    DropdownRoles
  }
}
</script>
